#! /bin/bash

cd ./src

CC=" gcc -c "
LD=" gcc "

CFLAGS=" -O3 -I. -I../ext/include -DDLL_PATH_ADD=\"./ext/dyn\" "

LFLAGS=" -L. -L../ext/lib -o SolarSys "

LIBS=" -ldl -lGLU -lGL "

OBJS=" solar_system.o planck_functions.o ui_element.o gluf.o aluf.o stage.o scene_api.o root_scene.o ext_libs.o planck_scene.o instruments_scene.o credits_scene.o gltf.o video_recorder.o recorder_controls.o 3d_collider.o renderer_controls.o std_decor.o file_parser.o hotspot.o platform.o "
VRJ_OBJS=" vrj_app.o sim_main1.o "
GLFW_OBJS=" glfw_viewer.o "

$CC $CFLAGS ext_libs.c
$CC $CFLAGS gluf.c
$CC $CFLAGS aluf.c
$CC $CFLAGS glfw_viewer.c
$CC $CFLAGS solar_system.c
$CC $CFLAGS planck_functions.c
$CC $CFLAGS ui_element.c
$CC $CFLAGS scene_api.c
$CC $CFLAGS stage.c
$CC $CFLAGS root_scene.c
$CC $CFLAGS planck_scene.c
$CC $CFLAGS instruments_scene.c
$CC $CFLAGS credits_scene.c
$CC $CFLAGS gltf.c
$CC $CFLAGS video_recorder.c
$CC $CFLAGS recorder_controls.c
$CC $CFLAGS 3d_collider.c
$CC $CFLAGS renderer_controls.c
$CC $CFLAGS std_decor.c
$CC $CFLAGS file_parser.c
$CC $CFLAGS hotspot.c
$CC $CFLAGS platform.c

$LD $LFLAGS $GLFW_OBJS $OBJS $GLFW_LIBS $LIBS

mv SolarSys ../SolarSys

rm *.o

cd ..

