#ifdef __cplusplus
extern "C" {
#endif

typedef struct { float x, y, z, r; } c3d_volume;

typedef struct {
   float pos_x, pos_y, pos_z;
   float rot_x, rot_y, rot_z;
   float time;
   float dt;
   int button;
}
c3d_update;

typedef struct c3d_domain c3d_domain;

/* protoype c3d_element */
typedef struct c3d_element c3d_element;
struct c3d_element {
   #define IMPLEMENTS_C3D_ELEMENT \
   c3d_element* more;\
   c3d_element* back;\
   c3d_domain* container;\
   void (*erase)(void* self);\
   void (*display)(void* self);\
   void (*update)(void* self,c3d_update* info);\
   void (*on_hit)(void* self,c3d_element* who);\
   void (*no_hit)(void* self,c3d_element* who);\
   c3d_volume at;\
   void *owner;\
   unsigned initiator;\
   unsigned id;
   IMPLEMENTS_C3D_ELEMENT
};

/* prototype c3d_item */
typedef struct c3d_item c3d_item;
struct c3d_item {
   c3d_item* next;
   c3d_item* back;
   c3d_item* up;
   void (*erase)(void* self);
   c3d_element* what;
};

/* protoype c3d_domain  */
struct c3d_domain {
   void (*erase)(void* self);
   void (*display)(void* self);
   void (*update)(void* self,c3d_update* info);
   void (*add_object)(c3d_domain* self,void* what);
   void (*add_objects)(c3d_domain* self, int number_of_items, ...);
   void (*remove_object)(c3d_domain* self, void* what);
   void (*add_collidable)(c3d_domain* self,void* what);
   void (*remove_collidable)(c3d_domain* self, void* what);
   c3d_element* contains;
   c3d_item* collidable;
};

c3d_volume in_volume(float x, float y, float z, float r);

c3d_domain *c3d_create_domain(void);
c3d_element* c3d_create_element(c3d_volume at);

#ifdef __cplusplus
}
#endif

