#ifndef __ALUF_H__
#define __ALUF_H__

/* OpenAL utility functions (ALUF) */

#ifdef __cplusplus
extern "C" {
#endif

#define USING_OPENAL_RUNTIME_LD
#define USING_MPG123_RUNTIME_LD
#define USING_OGGVORBIS_RUNTIME_LD

#include "ext_libs.h"

typedef struct stream_src stream_src;
struct stream_src {
   void (*read)(stream_src *src);
   void (*seek)(stream_src *src, double time);
   void (*erase)(stream_src *src);

   int serial_no;
   ALuint src;
   unsigned format;
   unsigned rate;
   unsigned long data_size;
   unsigned long data_read;
   double total_time;

   unsigned char *buff_data;
   unsigned buff_data_read;

   char *file_name;
   void *file_ptr;
   void *tid;
   unsigned run;
   unsigned poll_time;
   unsigned ready;
};


void aluf_init(void);
int  aluf_register_active_thread(void);
void aluf_unregister_active_thread(int t);
void aluf_destroy(void);

ALuint aluf_buffer_from(const char *snd_file);
unsigned int aluf_verify(ALuint source, ALuint buffer);

stream_src *create_stream_source(const char *file);
void erase_stream_source(stream_src *src);


#ifdef __cplusplus
}
#endif

#endif /* __ALUF_H__ */
