/*
   This library is intended to be a common area to "hide" dll loading
   code for all dynamic libraries. It is expected to grow as more
   functions are added with time.
*/

#ifndef _EXT_LIBS_H_
#define _EXT_LIBS_H_
#ifdef __cplusplus
   extern "C" {
#endif




/***************************** BEGIN COMMON ***********************************/
void ext_libs_unload(void);

/****************************** END COMMON ************************************/



/****************************** BEGIN GLFW ************************************/
#if defined(USING_GLFW)
   #include <GL/glfw.h>
#endif

#ifdef USING_GLFW_RUNTIME_LD
#define GLFW_DLL
#include <GL/glfw.h>

typedef int  (GLFWAPIENTRY *PGLFWINIT)(void);
typedef void (GLFWAPIENTRY *PGLFWTERMINATE)(void);
typedef int  (GLFWAPIENTRY *PGLFWGETVIDEOMODES)(GLFWvidmode*,int);
typedef void (GLFWAPIENTRY *PGLFWGETDESKTOPMODE)(GLFWvidmode*);
typedef void (GLFWAPIENTRY *PGLFWOPENWINDOWHINT)(int,int);
typedef int  (GLFWAPIENTRY *PGLFWOPENWINDOW)(int,int,int,int,int,int,int,int,int);
typedef void (GLFWAPIENTRY *PGLFWSWAPBUFFERS)(void);
typedef void (GLFWAPIENTRY *PGLFWENABLE)(int);
typedef void (GLFWAPIENTRY *PGLFWDISABLE)(int);
typedef void (GLFWAPIENTRY *PGLFWSETWINDOWPOS)(int,int);
typedef void (GLFWAPIENTRY *PGLFWSETWINDOWTITLE)(const char*);
typedef void (GLFWAPIENTRY *PGLFWSETWINDOWCLOSECALLBACK)(GLFWwindowclosefun);
typedef void (GLFWAPIENTRY *PGLFWSETWINDOWSIZECALLBACK)(GLFWwindowsizefun);
typedef void (GLFWAPIENTRY *PGLFWSETKEYCALLBACK)(GLFWkeyfun);
typedef void (GLFWAPIENTRY *PGLFWSETMOUSEBUTTONCALLBACK)(GLFWmousebuttonfun);
typedef void (GLFWAPIENTRY *PGLFWSETMOUSEWHEELCALLBACK)(GLFWmousewheelfun);
typedef void (GLFWAPIENTRY *PGLFWGETWINDOWSIZE)(int*,int*);
typedef void (GLFWAPIENTRY *PGLFWGETMOUSEPOS)(int*,int*);
typedef int  (GLFWAPIENTRY *PGLFWGETKEY)(int);
typedef int  (GLFWAPIENTRY *PGLFWGETMOUSEBUTTON)(int);

#define  glfwInit                               _glfwInit
#define  glfwTerminate                          _glfwTerminate
#define  glfwGetVideoModes                      _glfwGetVideoModes
#define  glfwGetDesktopMode                     _glfwGetDesktopMode
#define  glfwOpenWindowHint                     _glfwOpenWindowHint
#define  glfwOpenWindow                         _glfwOpenWindow
#define  glfwSwapBuffers                        _glfwSwapBuffers
#define  glfwEnable                             _glfwEnable
#define  glfwDisable                            _glfwDisable
#define  glfwSetWindowPos                       _glfwSetWindowPos
#define  glfwSetWindowTitle                     _glfwSetWindowTitle
#define  glfwSetWindowCloseCallback             _glfwSetWindowCloseCallback
#define  glfwSetWindowSizeCallback              _glfwSetWindowSizeCallback
#define  glfwSetKeyCallback                     _glfwSetKeyCallback
#define  glfwSetMouseButtonCallback             _glfwSetMouseButtonCallback
#define  glfwSetMouseWheelCallback              _glfwSetMouseWheelCallback
#define  glfwGetWindowSize                      _glfwGetWindowSize
#define  glfwGetMousePos                        _glfwGetMousePos
#define  glfwGetKey                             _glfwGetKey
#define  glfwGetMouseButton                     _glfwGetMouseButton

extern   PGLFWINIT                              glfwInit;
extern   PGLFWTERMINATE                         glfwTerminate;
extern   PGLFWGETVIDEOMODES                     glfwGetVideoModes;
extern   PGLFWGETDESKTOPMODE                    glfwGetDesktopMode;
extern   PGLFWOPENWINDOWHINT                    glfwOpenWindowHint;
extern   PGLFWOPENWINDOW                        glfwOpenWindow;
extern   PGLFWSWAPBUFFERS                       glfwSwapBuffers;
extern   PGLFWENABLE                            glfwEnable;
extern   PGLFWDISABLE                           glfwDisable;
extern   PGLFWSETWINDOWPOS                      glfwSetWindowPos;
extern   PGLFWSETWINDOWTITLE                    glfwSetWindowTitle;
extern   PGLFWSETWINDOWCLOSECALLBACK            glfwSetWindowCloseCallback;
extern   PGLFWSETWINDOWSIZECALLBACK             glfwSetWindowSizeCallback;
extern   PGLFWSETKEYCALLBACK                    glfwSetKeyCallback;
extern   PGLFWSETMOUSEBUTTONCALLBACK            glfwSetMouseButtonCallback;
extern   PGLFWSETMOUSEWHEELCALLBACK             glfwSetMouseWheelCallback;
extern   PGLFWGETWINDOWSIZE                     glfwGetWindowSize;
extern   PGLFWGETMOUSEPOS                       glfwGetMousePos;
extern   PGLFWGETKEY                            glfwGetKey;
extern   PGLFWGETMOUSEBUTTON                    glfwGetMouseButton;

unsigned int ext_load_glfw(void);

#endif
/******************************* END GLFW *************************************/



/***************************** BEGIN OPENAL ***********************************/
#if defined(USING_OPENAL) || defined(USING_OPENAL_RUNTIME_LD)
   #ifdef USING_OPENAL_RUNTIME_LD
      #define AL_NO_PROTOTYPES
   #endif
   #include <AL/al.h>
   #include <AL/alc.h>
#endif

#ifdef USING_OPENAL_RUNTIME_LD

#define  alcOpenDevice                             _alcOpenDevice
#define  alcCreateContext                          _alcCreateContext
#define  alcMakeContextCurrent                     _alcMakeContextCurrent
#define  alcDestroyContext                         _alcDestroyContext
#define  alcCloseDevice                            _alcCloseDevice
#define  alcGetCurrentContext                      _alcGetCurrentContext
#define  alcGetContextsDevice                      _alcGetContextsDevice
#define  alcGetString                              _alcGetString
#define  alcCaptureOpenDevice                      _alcCaptureOpenDevice
#define  alcCaptureStart                           _alcCaptureStart
#define  alcCaptureStop                            _alcCaptureStop
#define  alcGetIntegerv                            _alcGetIntegerv
#define  alcCaptureSamples                         _alcCaptureSamples
#define  alcCaptureCloseDevice                     _alcCaptureCloseDevice

#define  alGetError                                _alGetError
#define  alGenSources                              _alGenSources
#define  alGenBuffers                              _alGenBuffers
#define  alSourcef                                 _alSourcef
#define  alSourcei                                 _alSourcei
#define  alGetSourcei                              _alGetSourcei
#define  alIsSource                                _alIsSource
#define  alSourceStop                              _alSourceStop
#define  alSourcePlay                              _alSourcePlay
#define  alSourcePause                             _alSourcePause
#define  alBufferData                              _alBufferData
#define  alDeleteBuffers                           _alDeleteBuffers
#define  alDeleteSources                           _alDeleteSources
#define  alSourceQueueBuffers                      _alSourceQueueBuffers
#define  alSourceUnqueueBuffers                    _alSourceUnqueueBuffers

extern   LPALCOPENDEVICE                           alcOpenDevice;
extern   LPALCCREATECONTEXT                        alcCreateContext;
extern   LPALCMAKECONTEXTCURRENT                   alcMakeContextCurrent;
extern   LPALCDESTROYCONTEXT                       alcDestroyContext;
extern   LPALCCLOSEDEVICE                          alcCloseDevice;
extern   LPALCGETCURRENTCONTEXT                    alcGetCurrentContext;
extern   LPALCGETCONTEXTSDEVICE                    alcGetContextsDevice;
extern   LPALCGETSTRING                            alcGetString;
extern   LPALCCAPTUREOPENDEVICE                    alcCaptureOpenDevice;
extern   LPALCCAPTURESTART                         alcCaptureStart;
extern   LPALCCAPTURESTOP                          alcCaptureStop;
extern   LPALCGETINTEGERV                          alcGetIntegerv;
extern   LPALCCAPTURESAMPLES                       alcCaptureSamples;
extern   LPALCCAPTURECLOSEDEVICE                   alcCaptureCloseDevice;

extern   LPALGETERROR                              alGetError;
extern   LPALGENSOURCES                            alGenSources;
extern   LPALGENBUFFERS                            alGenBuffers;
extern   LPALSOURCEF                               alSourcef;
extern   LPALSOURCEI                               alSourcei;
extern   LPALGETSOURCEI                            alGetSourcei;
extern   LPALISSOURCE                              alIsSource;
extern   LPALSOURCESTOP                            alSourceStop;
extern   LPALSOURCEPLAY                            alSourcePlay;
extern   LPALSOURCEPAUSE                           alSourcePause;
extern   LPALBUFFERDATA                            alBufferData;
extern   LPALDELETEBUFFERS                         alDeleteBuffers;
extern   LPALDELETESOURCES                         alDeleteSources;
extern   LPALSOURCEQUEUEBUFFERS                    alSourceQueueBuffers;
extern   LPALSOURCEUNQUEUEBUFFERS                  alSourceUnqueueBuffers;

unsigned int ext_load_OpenAL(void);

#endif
/******************************** END OPENAL **********************************/



/******************************* BEGIN MPG123 *********************************/
#if defined(USING_MPG123) || defined(USING_MPG123_RUNTIME_LD)
   #include <mpg123.h>
#endif

#ifdef USING_MPG123_RUNTIME_LD

typedef  int (*PMPG123_INIT)(void);
typedef  void (*PMPG123_EXIT)(void);
typedef  const char *(*PMPG123_PLAIN_STRERROR)(int);
typedef  const char *(*PMPG123_STRERROR)(mpg123_handle*);
typedef  mpg123_handle *(*PMPG123_NEW)(const char*,int*);
typedef  void (*PMPG123_DELETE)(mpg123_handle*);
typedef  int (*PMPG123_OPEN)(mpg123_handle*,const char*);
typedef  int (*PMPG123_CLOSE)(mpg123_handle*);
typedef  int (*PMPG123_FORMAT_NONE)(mpg123_handle*);
typedef  int (*PMPG123_GETFORMAT)(mpg123_handle*,long*,int*,int*);
typedef  int (*PMPG123_FORMAT)(mpg123_handle*,long,int,int);
typedef  int (*PMPG123_READ)(mpg123_handle*,unsigned char*,size_t,size_t*);
typedef  off_t (*PMPG123_LENGTH)(mpg123_handle *mh);
typedef  off_t (*PMPG123_SEEK)(mpg123_handle *mh, off_t sampleoff, int whence);

#define  mpg123_init                               _mpg123_init
#define  mpg123_exit                               _mpg123_exit
#define  mpg123_plain_strerror                     _mpg123_plain_strerror
#define  mpg123_strerror                           _mpg123_strerror
#define  mpg123_new                                _mpg123_new
#define  mpg123_delete                             _mpg123_delete
#define  mpg123_open                               _mpg123_open
#define  mpg123_close                              _mpg123_close
#define  mpg123_getformat                          _mpg123_getformat
#define  mpg123_format_none                        _mpg123_format_none
#define  mpg123_format                             _mpg123_format
#define  mpg123_read                               _mpg123_read
#define  mpg123_length                             _mpg123_length
#define  mpg123_seek                               _mpg123_seek

extern   PMPG123_INIT                              mpg123_init;
extern   PMPG123_EXIT                              mpg123_exit;
extern   PMPG123_PLAIN_STRERROR                    mpg123_plain_strerror;
extern   PMPG123_STRERROR                          mpg123_strerror;
extern   PMPG123_NEW                               mpg123_new;
extern   PMPG123_DELETE                            mpg123_delete;
extern   PMPG123_OPEN                              mpg123_open;
extern   PMPG123_CLOSE                             mpg123_close;
extern   PMPG123_FORMAT_NONE                       mpg123_format_none;
extern   PMPG123_GETFORMAT                         mpg123_getformat;
extern   PMPG123_FORMAT                            mpg123_format;
extern   PMPG123_READ                              mpg123_read;
extern   PMPG123_LENGTH                            mpg123_length;
extern   PMPG123_SEEK                              mpg123_seek;


unsigned int ext_load_mpg123(void);

#endif
/******************************** END MPG123 **********************************/



/******************************* BEGIN OGGVORBIS ******************************/
#if defined(USING_OGGVORBIS) || defined(USING_OGGVORBIS_RUNTIME_LD)
   #include <vorbis/vorbisfile.h>
#endif

#ifdef USING_OGGVORBIS_RUNTIME_LD

typedef  int (*POV_OPEN_CALLBACKS)(void*,OggVorbis_File*,char*,long,ov_callbacks);
typedef  vorbis_info *(*POV_INFO)(OggVorbis_File*,int);
typedef  int (*POV_CLEAR)(OggVorbis_File*);
typedef  long (*POV_READ)(OggVorbis_File*,char*,int,int,int,int,int*);
typedef  double (*POV_TIME_TOTAL)(OggVorbis_File *vf,int i);
typedef  ogg_int64_t (*POV_PCM_TOTAL)(OggVorbis_File *vf,int i);
typedef  int (*POV_TIME_SEEK)(OggVorbis_File *vf,double pos);

#define  ov_open_callbacks                         _ov_open_callbacks
#define  ov_info                                   _ov_info
#define  ov_clear                                  _ov_clear
#define  ov_read                                   _ov_read
#define  ov_time_total                             _ov_time_total
#define  ov_pcm_total                              _ov_pcm_total
#define  ov_time_seek                              _ov_time_seek


extern   POV_OPEN_CALLBACKS                        ov_open_callbacks;
extern   POV_INFO                                  ov_info;
extern   POV_CLEAR                                 ov_clear;
extern   POV_READ                                  ov_read;
extern   POV_TIME_TOTAL                            ov_time_total;
extern   POV_PCM_TOTAL                             ov_pcm_total;
extern   POV_TIME_SEEK                             ov_time_seek;

unsigned int ext_load_ogg_vorbis(void);

#endif
/******************************** END OGGVORBIS *******************************/



/******************************** BEGIN FREEIMAGE *****************************/
#if defined(USING_FREEIMAGE) || defined(USING_FREEIMAGE_RUNTIME_LD)
   #include <FreeImage.h>
#endif

#ifdef USING_FREEIMAGE_RUNTIME_LD

typedef FREE_IMAGE_FORMAT (DLL_CALLCONV *PFREEIMAGE_GETFILETYPE)(const char*,int);
typedef FREE_IMAGE_FORMAT (DLL_CALLCONV *PFREEIMAGE_GETFIFFROMFILENAME)(const char*);
typedef BOOL (DLL_CALLCONV *PFREEIMAGE_FIFSUPPORTSREADING)(FREE_IMAGE_FORMAT);
typedef FIBITMAP *(DLL_CALLCONV *PFREEIMAGE_LOAD)(FREE_IMAGE_FORMAT,const char*,int);
typedef BYTE *(DLL_CALLCONV *PFREEIMAGE_GETBITS)(FIBITMAP*);
typedef unsigned (DLL_CALLCONV *PFREEIMAGE_GETWIDTH)(FIBITMAP*);
typedef unsigned (DLL_CALLCONV *PFREEIMAGE_GETHEIGHT)(FIBITMAP*);
typedef unsigned (DLL_CALLCONV *PFREEIMAGE_GETBPP)(FIBITMAP*);
typedef void (DLL_CALLCONV *PFREEIMAGE_UNLOAD)(FIBITMAP*);
typedef FIBITMAP *(DLL_CALLCONV *PFREEIMAGE_RESCALE)(FIBITMAP*,int,int,FREE_IMAGE_FILTER);
typedef FIBITMAP *(DLL_CALLCONV *PFREEIMAGE_ALLOCATE)(int,int,int,unsigned,unsigned,unsigned);
typedef BOOL (DLL_CALLCONV *PFREEIMAGE_SAVE)(FREE_IMAGE_FORMAT,FIBITMAP*,const char*,int);
typedef FIBITMAP *(DLL_CALLCONV *PFREEIMAGE_CONVERTFROMRAWBITS)(BYTE*,int,int,int,unsigned,unsigned,unsigned,unsigned,BOOL);
typedef BOOL (DLL_CALLCONV *PFREEIMAGE_FIFSUPPORTSWRITING)(FREE_IMAGE_FORMAT);



#define  FreeImage_GetFileType                  _FreeImage_GetFileType
#define  FreeImage_GetFIFFromFilename           _FreeImage_GetFIFFromFilename
#define  FreeImage_FIFSupportsReading           _FreeImage_FIFSupportsReading
#define  FreeImage_Load                         _FreeImage_Load
#define  FreeImage_GetBits                      _FreeImage_GetBits
#define  FreeImage_GetWidth                     _FreeImage_GetWidth
#define  FreeImage_GetHeight                    _FreeImage_GetHeight
#define  FreeImage_GetBPP                       _FreeImage_GetBPP
#define  FreeImage_Unload                       _FreeImage_Unload
#define  FreeImage_Rescale                      _FreeImage_Rescale
#define  FreeImage_Allocate                     _FreeImage_Allocate
#define  FreeImage_Save                         _FreeImage_Save
#define  FreeImage_ConvertFromRawBits           _FreeImage_ConvertFromRawBits
#define  FreeImage_FIFSupportsWriting           _FreeImage_FIFSupportsWriting


extern   PFREEIMAGE_GETFILETYPE                 FreeImage_GetFileType;
extern   PFREEIMAGE_GETFIFFROMFILENAME          FreeImage_GetFIFFromFilename;
extern   PFREEIMAGE_FIFSUPPORTSREADING          FreeImage_FIFSupportsReading;
extern   PFREEIMAGE_LOAD                        FreeImage_Load;
extern   PFREEIMAGE_GETBITS                     FreeImage_GetBits;
extern   PFREEIMAGE_GETWIDTH                    FreeImage_GetWidth;
extern   PFREEIMAGE_GETHEIGHT                   FreeImage_GetHeight;
extern   PFREEIMAGE_GETBPP                      FreeImage_GetBPP;
extern   PFREEIMAGE_UNLOAD                      FreeImage_Unload;
extern   PFREEIMAGE_RESCALE                     FreeImage_Rescale;
extern   PFREEIMAGE_ALLOCATE                    FreeImage_Allocate;
extern   PFREEIMAGE_SAVE                        FreeImage_Save;
extern   PFREEIMAGE_CONVERTFROMRAWBITS          FreeImage_ConvertFromRawBits;
extern   PFREEIMAGE_FIFSUPPORTSWRITING          FreeImage_FIFSupportsWriting;

unsigned int ext_load_freeimage(void);

#endif
/********************************* END FREEIMAGE ******************************/



/*********************************** BEGIN REVEL ******************************/
#if defined(USING_REVEL) || defined(USING_REVEL_RUNTIME_LD)
   #include <revel.h>
#endif

#ifdef USING_REVEL_RUNTIME_LD

typedef  int            (*PREVEL_GETVERSION)(void);
typedef  int            (*PREVEL_GETAPIVERSION)(void);
typedef  Revel_Error    (*PREVEL_CREATEENCODER)(int*);
typedef  void           (*PREVEL_INITIALIZEPARAMS)(Revel_Params*);
typedef  Revel_Error    (*PREVEL_ENCODESTART)(int,const char*,Revel_Params*);
typedef  Revel_Error    (*PREVEL_ENCODEFRAME)(int,Revel_VideoFrame*,int*);
typedef  Revel_Error    (*PREVEL_ENCODEAUDIO)(int,void*,int,int*);
typedef  Revel_Error    (*PREVEL_ENCODEEND)(int,int*);
typedef  Revel_Error    (*PREVEL_DESTROYENCODER)(int);


#define  Revel_GetVersion                       _Revel_GetVersion
#define  Revel_GetApiVersion                    _Revel_GetApiVersion
#define  Revel_CreateEncoder                    _Revel_CreateEncoder
#define  Revel_InitializeParams                 _Revel_InitializeParams
#define  Revel_EncodeStart                      _Revel_EncodeStart
#define  Revel_EncodeFrame                      _Revel_EncodeFrame
#define  Revel_EncodeAudio                      _Revel_EncodeAudio
#define  Revel_EncodeEnd                        _Revel_EncodeEnd
#define  Revel_DestroyEncoder                   _Revel_DestroyEncoder

extern   PREVEL_GETVERSION                      Revel_GetVersion;
extern   PREVEL_GETAPIVERSION                   Revel_GetApiVersion;
extern   PREVEL_CREATEENCODER                   Revel_CreateEncoder;
extern   PREVEL_INITIALIZEPARAMS                Revel_InitializeParams;
extern   PREVEL_ENCODESTART                     Revel_EncodeStart;
extern   PREVEL_ENCODEFRAME                     Revel_EncodeFrame;
extern   PREVEL_ENCODEAUDIO                     Revel_EncodeAudio;
extern   PREVEL_ENCODEEND                       Revel_EncodeEnd;
extern   PREVEL_DESTROYENCODER                  Revel_DestroyEncoder;

unsigned int ext_load_revel(void);

#endif
/*********************************** END REVEL ********************************/



#ifdef __cplusplus
}
#endif

#endif
