#ifndef __GEOM_LIST_H__
#define __GEOM_LIST_H__

#include "matrix44.h"

typedef union {
   struct {
      vec4     Ka;
      vec4     Kd;
      vec4     Ks;
      vec4     Ke;
      FLOAT_T  Ns;
      UINT_T   map;
   };
   struct { FLOAT_T r, g, b, a, _[13]; UINT_T tex; };
   FLOAT_T clr_mat[17];
}
material_t;

typedef union {
   struct {
      vec4     La;
      vec4     Ld;
      vec4     Ls;
      vec4     Lp;
      FLOAT_T  cutoff_distance;
      FLOAT_T  minimum_level;
   };
   struct { FLOAT_T r, g, b, a, _[8], x, y, z, w; };
}
light_t;

typedef struct {
   UINT_T      vertex_count;
   UINT_T      vertex_start;  /* size: vertex_count * 3 * FLOAT_T */
   UINT_T      normal_start;  /* size: vertex_count * 3 * FLOAT_T */
   UINT_T      texture_start; /* size: vertex_count * 2 * FLOAT_T */
   UINT_T      color_start;   /* size: vertex_count * 4 * FLOAT_T */
   material_t  material;
}
geom_part_t;

typedef struct {
   void        *array;
   UINT_T      array_bytes;

   unsigned    part_count;
   geom_part_t *part; /* array */

   light_t     light;
}
geom_list;

geom_list *create_geom_list(void);
void geom_list_free(geom_list *list);

#endif /* __GEOM_LIST_H__ */