#ifndef __GL_EXTENSIONS_H__
#define __GL_EXTENSIONS_H__

#define USING_OPENGL
#include "platform.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _USE_MSVC
 /* Mangle GL function names on POSIX, as they are usually defined symbols and
      typically non-functional... */
   #define glGenBuffers                      _glGenBuffers
   #define glBindBuffer                      _glBindBuffer
   #define glBufferData                      _glBufferData
   #define glBufferSubData                   _glBufferSubData
   #define glDeleteBuffers                   _glDeleteBuffers;
   #define glGetBufferParameteriv            _glGetBufferParameteriv
   #define glMapBuffer                       _glMapBuffer
   #define glUnmapBuffer                     _glUnmapBuffer
   #define glDrawRangeElements               _glDrawRangeElements
   #define glGetBufferSubData                _glGetBufferSubData
   #define glIsBuffer                        _glIsBuffer

   #define glCreateShader                    _glCreateShader
   #define glShaderSource                    _glShaderSource
   #define glCompileShader                   _glCompileShader
   #define glGetShaderiv                     _glGetShaderiv
   #define glGetShaderInfoLog                _glGetShaderInfoLog
   #define glIsShader                        _glIsShader
   #define glDeleteShader                    _glDeleteShader
   #define glCreateProgram                   _glCreateProgram
   #define glAttachShader                    _glAttachShader
   #define glDetachShader                    _glDetachShader
   #define glLinkProgram                     _glLinkProgram
   #define glGetProgramiv                    _glGetProgramiv
   #define glGetProgramInfoLog               _glGetProgramInfoLog
   #define glUseProgram                      _glUseProgram
   #define glValidateProgram                 _glValidateProgram
   #define glIsProgram                       _glIsProgram
   #define glDeleteProgram                   _glDeleteProgram
   #define glGetUniformLocation              _glGetUniformLocation
   #define glGetAttribLocation               _glGetAttribLocation
   #define glBindAttribLocation              _glBindAttribLocation
   #define glVertexAttribPointer             _glVertexAttribPointer
   #define glEnableVertexAttribArray         _glEnableVertexAttribArray
   #define glDisableVertexAttribArray        _glDisableVertexAttribArray
   #define glUniform1f                       _glUniform1f
   #define glUniform2f                       _glUniform2f
   #define glUniform3f                       _glUniform3f
   #define glUniform4f                       _glUniform4f
   #define glUniform1i                       _glUniform1i
   #define glUniform2i                       _glUniform2i
   #define glUniform3i                       _glUniform3i
   #define glUniform4i                       _glUniform4i
   #define glUniform1fv                      _glUniform1fv
   #define glUniform2fv                      _glUniform2fv
   #define glUniform3fv                      _glUniform3fv
   #define glUniform4fv                      _glUniform4fv
   #define glUniform1iv                      _glUniform1iv
   #define glUniform2iv                      _glUniform2iv
   #define glUniform3iv                      _glUniform3iv
   #define glUniform4iv                      _glUniform4iv
   #define glUniformMatrix2fv                _glUniformMatrix2fv
   #define glUniformMatrix3fv                _glUniformMatrix3fv
   #define glUniformMatrix4fv                _glUniformMatrix4fv
   #define glActiveTexture                   _glActiveTexture
#endif

extern PFNGLGENBUFFERSPROC                   glGenBuffers;
extern PFNGLBINDBUFFERPROC                   glBindBuffer;
extern PFNGLBUFFERDATAPROC                   glBufferData;
extern PFNGLBUFFERSUBDATAPROC                glBufferSubData;
extern PFNGLDELETEBUFFERSPROC                glDeleteBuffers;
extern PFNGLGETBUFFERPARAMETERIVPROC         glGetBufferParameteriv;
extern PFNGLMAPBUFFERPROC                    glMapBuffer;
extern PFNGLUNMAPBUFFERPROC                  glUnmapBuffer;
extern PFNGLDRAWRANGEELEMENTSPROC            glDrawRangeElements;
extern PFNGLGETBUFFERSUBDATAPROC             glGetBufferSubData;
extern PFNGLISBUFFERPROC                     glIsBuffer;

extern PFNGLSHADERSOURCEPROC                 glShaderSource;
extern PFNGLCOMPILESHADERPROC                glCompileShader;
extern PFNGLCREATESHADERPROC                 glCreateShader;
extern PFNGLGETSHADERIVPROC                  glGetShaderiv;
extern PFNGLGETSHADERINFOLOGPROC             glGetShaderInfoLog;
extern PFNGLISSHADERPROC                     glIsShader;
extern PFNGLDELETESHADERPROC                 glDeleteShader;

extern PFNGLCREATEPROGRAMPROC                glCreateProgram;
extern PFNGLATTACHSHADERPROC                 glAttachShader;
extern PFNGLDETACHSHADERPROC                 glDetachShader;
extern PFNGLLINKPROGRAMPROC                  glLinkProgram;
extern PFNGLGETPROGRAMIVPROC                 glGetProgramiv;
extern PFNGLGETPROGRAMINFOLOGPROC            glGetProgramInfoLog;
extern PFNGLUSEPROGRAMPROC                   glUseProgram;
extern PFNGLDELETEPROGRAMPROC                glDeleteProgram;
extern PFNGLISPROGRAMPROC                    glIsProgram;
extern PFNGLVALIDATEPROGRAMPROC              glValidateProgram;

extern PFNGLGETUNIFORMLOCATIONPROC           glGetUniformLocation;
extern PFNGLGETATTRIBLOCATIONPROC            glGetAttribLocation;
extern PFNGLBINDATTRIBLOCATIONPROC           glBindAttribLocation;
extern PFNGLVERTEXATTRIBPOINTERPROC          glVertexAttribPointer;
extern PFNGLENABLEVERTEXATTRIBARRAYPROC      glEnableVertexAttribArray;
extern PFNGLDISABLEVERTEXATTRIBARRAYPROC     glDisableVertexAttribArray;

extern PFNGLUNIFORM1FPROC                    glUniform1f;
extern PFNGLUNIFORM2FPROC                    glUniform2f;
extern PFNGLUNIFORM3FPROC                    glUniform3f;
extern PFNGLUNIFORM4FPROC                    glUniform4f;
extern PFNGLUNIFORM1IPROC                    glUniform1i;
extern PFNGLUNIFORM2IPROC                    glUniform2i;
extern PFNGLUNIFORM3IPROC                    glUniform3i;
extern PFNGLUNIFORM4IPROC                    glUniform4i;
extern PFNGLUNIFORM1FVPROC                   glUniform1fv;
extern PFNGLUNIFORM2FVPROC                   glUniform2fv;
extern PFNGLUNIFORM3FVPROC                   glUniform3fv;
extern PFNGLUNIFORM4FVPROC                   glUniform4fv;
extern PFNGLUNIFORM1IVPROC                   glUniform1iv;
extern PFNGLUNIFORM2IVPROC                   glUniform2iv;
extern PFNGLUNIFORM3IVPROC                   glUniform3iv;
extern PFNGLUNIFORM4IVPROC                   glUniform4iv;
extern PFNGLUNIFORMMATRIX2FVPROC             glUniformMatrix2fv;
extern PFNGLUNIFORMMATRIX3FVPROC             glUniformMatrix3fv;
extern PFNGLUNIFORMMATRIX4FVPROC             glUniformMatrix4fv;
extern PFNGLACTIVETEXTUREPROC                glActiveTexture;


unsigned gl_extensions_init(void);

#ifdef __cplusplus
}
#endif

#endif /* __GL_EXTENSIONS_H */