#ifndef __HOTSPOT_H__
#define __HOTSPOT_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "3d_collider.h"
#include "ui_element.h"
#include "aluf.h"

enum {HS_NO = 0,HS_YES = 1};

enum { FROM_FILE = 1, FROM_STRING } hotspot_mode;

typedef enum {
   HS_USE_AUDIO,
   HS_SHOW_VISUAL,
   HS_AUDIO_LEVEL,
   HS_SUSPEND
}
hotspot_directive;

typedef struct c3d_ui_hotspot c3d_ui_hotspot;
struct c3d_ui_hotspot {
   #define IMPLEMENTS_UI_C3D_HOTSPOT \
   IMPLEMENTS_UI_ELEMENT \
   AND_UI_CONTAINER \
   void (*set)(c3d_ui_hotspot *h,hotspot_directive what, float value);\
   c3d_domain *spots;
   IMPLEMENTS_UI_C3D_HOTSPOT
};



c3d_ui_hotspot *create_c3d_ui_hotspot(const char *src, unsigned mode);



#ifdef __cplusplus
}
#endif

#endif /* __HOTSPOT_H__ */