#ifndef __MATRIX_LIBRARY__
#define __MATRIX_LIBRARY__

#include "matrix_library_constants.h"
#include "matrix44.h"

/* Sets up matrix stacks, etc... */
void mlInit(void);
//void mlShutdown(void);

void mlMatrixMode(ENUM_T mode);
void mlPushMatrix(void);
void mlPopMatrix(void);

void mlLoadIdentity(void);
void mlMultMatrixf(mat44 *m);
void mlLoadMatrixf(mat44 *m);

/* Non-standard replacements for glGet(GL_PROJECTION_MATRIX) and
   glGet(GL_MODELVIEW_MATRIX). */
void mlGetProjectionMatrix(FLOAT_T *m);
void mlGetModelviewMatrix(FLOAT_T *m);
FLOAT_T *mlGetMVPMatrix(void);

void mlFrustum(FLOAT_T left, FLOAT_T right, FLOAT_T bottom, FLOAT_T top, FLOAT_T znear, FLOAT_T zfar);
void mlOrtho(FLOAT_T left, FLOAT_T right, FLOAT_T bottom, FLOAT_T top, FLOAT_T znear, FLOAT_T zfar);

void mlTranslatef(FLOAT_T x, FLOAT_T y, FLOAT_T z);
void mlRotatef(FLOAT_T angle, FLOAT_T x, FLOAT_T y, FLOAT_T z);
void mlScalef(FLOAT_T x, FLOAT_T y, FLOAT_T z);

INT_T mlUnProject(
   FLOAT_T winx, FLOAT_T winy, FLOAT_T winz,
   mat44 *modelMatrix, mat44 *projMatrix, INT_T viewport[4],
   FLOAT_T *objx, FLOAT_T *objy, FLOAT_T *objz);


#endif