#ifndef __SCENE_API_H__
#define __SCENE_API_H__

#include "config_loader.h"
#include "matrix44.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct scene_api scene_api;
struct scene_api {

   #define IMPLEMENTS_SCENE_API \
   void (*init)(scene_api *self);\
   void (*update)(scene_api *self);\
   void (*draw)(scene_api *self);\
   void (*enter)(scene_api *self);\
   void (*leave)(scene_api *self);\
   void (*erase)(scene_api *self);\
   void (*audio_level)(scene_api *self, float value);\
   float illumination;\
   unsigned int initialized;\
   float eye_seperation;\
   float focal_plane;\
   float clipping_plane;\
   float rotation[3];\
   float position[3];\
   config_loader *cl;\
   config_aggregate *ca;\
   unsigned context;\
   mat44 *projection;

   IMPLEMENTS_SCENE_API
};

void scene_api_configure(scene_api *this_scene);
void scene_api_enter(scene_api *this_scene);
void scene_api_leave(scene_api *this_scene);
void scene_api_gl_defaults(void);
void scene_api_set_brightness(float level);


#ifdef __cplusplus
}
#endif

#endif /* __SCENE_API_H__ */