#ifndef __SHADER_API_H__
#define __SHADER_API_H__

#ifdef __cplusplus
extern "C" {
#endif

#define INIT_MODULE_NAME(x)			x,
#define INIT_VERTEX_SOURCE_BEGIN    0,0,0,
#define INIT_FRAGMENT_SOURCE_BEGIN  ,
#define INIT_ALLOCATED_SOURCES(x)   ,x
#define INIT_COMPILE_FUNCTION(x)		,x
#define INIT_STD_COMPILE_FUNCTION   ,&shader_std_compile_fn
#define INIT_ENUMERATE_FUNCTION(x)  ,x
#define INIT_EXECUTE_FUNCTION(x)    ,x
#define INIT_SHADER_API_BLOCK_END   ,

typedef void* shader_program;

typedef struct {
   #define IMPLEMENTS_SHADER_PROGRAM_API \
   char *name;\
   unsigned program;\
   unsigned vert_shader;\
   unsigned frag_shader;\
   char *vert_src;\
   char *frag_src;\
   unsigned allocated_srcs;\
   unsigned (*compile)(shader_program ptr,unsigned validate);\
   void (*enumerate)(shader_program ptr);\
   void (*execute)(shader_program ptr);

   IMPLEMENTS_SHADER_PROGRAM_API
}
shader_program_api;


unsigned shader_program_compile(shader_program ptr,unsigned validate);
void shader_program_execute(shader_program ptr);
void shader_program_free(shader_program ptr);

unsigned shader_std_compile_fn(shader_program ptr,unsigned validate);

#ifdef __cplusplus
}
#endif

#endif /* __SHADER_API_H__ */