#ifndef __SOLAR_SYSTEM_H__
#define __SOLAR_SYSTEM_H__


#ifdef __cplusplus
extern "C" {
#endif

#include "ui_element.h"


typedef struct solar_system solar_system;
struct solar_system {
   #define IMPLEMENTS_SOLAR_SYSTEM \
   void (*update)(solar_system *obj,double frame_dt);\
   void (*draw)(solar_system *obj, mat44 *projection, mat44 *modelview);\
   unsigned (*begin)(solar_system *obj);\
   void (*stop)(solar_system *obj);\
   void (*erase)(solar_system *obj);\
   ui_element *(*create_object_scale_ctl)(solar_system *obj);\
   ui_element *(*create_time_ctl)(solar_system *obj);\
   ui_element *(*create_time_scale_ctl)(solar_system *obj);\
   ui_element *(*create_location_ctl)(solar_system *obj);\
   ui_element *(*create_trace_ctl)(solar_system *obj);\
   ui_element *(*create_scan_map_ctl)(solar_system *obj);\
   ui_element *(*create_wire_frame_ctl)(solar_system *obj);\
   ui_element *(*create_marker_ctl)(solar_system *obj);\
   ui_element *(*create_star_map_ctl)(solar_system *obj);\
   ui_element *(*create_info_dsp)(solar_system *obj, float update_interval);\
   ui_element *(*create_hotkeys)(solar_system *obj);\
   ui_element *(*create_scan_ctl)(solar_system *obj);\
   ui_element *(*create_sky_panel)(solar_system *obj);\
   ui_element *(*create_scan_panel)(solar_system *obj);

   IMPLEMENTS_SOLAR_SYSTEM
};


solar_system *create_solar_system(unsigned skymap_on, unsigned traces_on,
                                        unsigned trace_fade,float object_scale,
                                        ui_cursor_fn *cursor,
                                        float *rotation_array);

#ifdef __cplusplus
}
#endif

#endif /* __SOLAR_SYSTEM_H__ */
