#ifndef __VIDEO_RECORDER_H__
#define __VIDEO_RECORDER_H__

#ifdef __cplusplus
extern "C" {
#endif


typedef struct video_recorder video_recorder;
struct video_recorder {
   #define IMPLEMENTS_VIDEO_RECORDER \
   void (*erase)(video_recorder *vr);\
   void (*done)(video_recorder *vr);\
   void (*wait_finish)(video_recorder *vr);\
   void (*record)(video_recorder *vr);\
   void (*pause)(video_recorder *vr);\
   void (*next_frame)(video_recorder *vr, double dt);\
   unsigned out_width;\
   unsigned out_height;\
   char *out_file;\
   double record_time;\
   unsigned long frames;\
   unsigned audio_active;\
   float quality;
   IMPLEMENTS_VIDEO_RECORDER
};


typedef struct {
   unsigned    in_width;
   unsigned    in_height;
   unsigned    out_width;
   unsigned    out_height;
   unsigned    out_fps;
   const char  *out_file;
   unsigned    use_audio;
   float       quality;
}
vr_params;

video_recorder *create_video_recorder(vr_params *in);
void video_recorder_wait_process_end(void);


#ifdef __cplusplus
}
#endif

#endif /* __VIDEO_RECORDER_H__ */